<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\CategoriaManutService;

class CategoriaManutController
{
    protected $CategoriaManutService;

    public function __construct(CategoriaManutService $CategoriaManutService) {
        $this->CategoriaManutService = $CategoriaManutService;
    }

    public function rotaBase(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        $parametros = $request->getParameters();
        $categoria = '';

        if ($method== "POST") {
            $categoria = $this->CategoriaManutService->insertNovaCategoriaManutencao($parametros);
        } else if ($method == "GET") {
            $categoria = $this->CategoriaManutService->getInformacoesCategoriaManut();
        }

        $dtsVal = new DataSet('categorias', [$categoria]);
        $response->addDataSet($dtsVal);
    }

    public function getFuncionarioCategoriaManut(DTO\Request $request, DTO\Response $response) {

        $funcionarios = $this->CategoriaManutService->getFuncionarioCategoriaManut();
        $dtsVal = new DataSet('funcionarios', $funcionarios);
        $response->addDataSet($dtsVal);
    }
}
