<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ImpactoManutService;

class ImpactoManutController
{
    protected $ImpactoManutService;

    public function __construct(ImpactoManutService $ImpactoManutService)
    {
        $this->ImpactoManutService = $ImpactoManutService;
    }

    public function rotaBase(DTO\Request $request, DTO\Response $response)
    {
        $method = $request->getMethod();
        $parametros = $request->getParameters();
        $impacto = '';

        if ($method == "POST") {
            $impacto = $this->ImpactoManutService->inserirImpacto($parametros);
        } else if ($method == "GET") {
            $impacto = $this->ImpactoManutService->getInformacoesImpacto();
        }

        $dtsVal = new DataSet('impacto', [$impacto]);
        $response->addDataSet($dtsVal);
    }

    public function listImpactos(DTO\Request $request, DTO\Response $response)
    {
        $impactos = $this->ImpactoManutService->listImpactos();
        $dtsVal = new DataSet('Impactos', $impactos);
        $response->addDataSet($dtsVal);
    }
}
