<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\OrdemServService;

class OrdemServController
{
    protected $OrdemServService;

    public function __construct(OrdemServService $OrdemServService)
    {
        $this->OrdemServService = $OrdemServService;
    }

    public function ordemServ(DTO\Request $request, DTO\Response $response)
    {
        $response->addDataSet(new DataSet('ordens', $this->OrdemServService->getOrdemServ(($request->getParameters())['NR'])));
    }

    public function getOrdensServicoParaDashboard(DTO\Request $request, DTO\Response $response)
    {
        $variavel = $this->OrdemServService->getOrdensServicoParaDashboard();
        $dtsVal = new DataSet('ordens', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getOrdensPendentes(DTO\Request $request, DTO\Response $response)
    {
        $variavel = $this->OrdemServService->getOrdensPendentes();
        $dtsVal = new DataSet('ordens', $variavel);
        $response->addDataSet($dtsVal);
    }
}
