<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class SolicitacaoServFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function insertSolicitacaoServ($params) {
        $sql = "INSERT INTO FCM_SOLICITACAOSERV (NRCATEGORIAMANUT,
            DTSOLICITACAOSERV, NRFUNCSOLICITANTE, NREQUIPAMENTO,
            DSSOLICITACAOSERV, NRIMPACTOMANUT, NMSOLICITACAOSERV,
            NRSOLICITACAOSERV)
        VALUES (:NRCATEGORIAMANUT, SYSDATE,
            :NRFUNCSOLICITANTE, :NREQUIPAMENTO, :DSSOLICITACAOSERV,
            :NRIMPACTOMANUT, :NMSOLICITACAOSERV, :NRSOLICITACAOSERV)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function getSolicitacoesServDash() {

      $sql = "SELECT SS.NRSOLICITACAOSERV, TO_CHAR(SS.DTSOLICITACAOSERV, 'DD/MM/YY') DTSOLICITACAOSERV,
              CAT.NMCATEGORIAMANUT,
                CASE SS.IDSITUACAO WHEN '1' THEN 'ABERTA'
                WHEN '2' THEN 'EM ANDAMENTO'
                    ELSE NULL END AS IDSITUACAO
                    FROM FCM_SOLICITACAOSERV SS
                    JOIN FCM_CATEGORIAMANUT CAT
                      ON CAT.NRCATEGORIAMANUT = SS.NRCATEGORIAMANUT
                   WHERE SS.IDSITUACAO IN (1,2)";

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }

    public function getSolicitacoeConvertidasOS() {

      $sql = "SELECT R.NRRELSOLICITAORDEMSERV, R.NRSOLICITACAOSERV, R.NRORDEMSERV, TO_CHAR (S.DTSOLICITACAOSERV, 'DD/MM/YY') DTSOLICITACAOSERV, CAT.NMCATEGORIAMANUT,
                CASE S.IDSITUACAO WHEN '1' THEN 'ABERTA'
                WHEN '2' THEN 'EM ANDAMENTO'
                WHEN '3' THEN 'EM ANÁLISE'
                WHEN '4' THEN 'CONCLUÍDA'
                    ELSE NULL END AS IDSITUACAO
                FROM FCM_RELSOLICITAORDEMSERV R
                JOIN FCM_SOLICITACAOSERV S
                  ON S.NRSOLICITACAOSERV = R.NRSOLICITACAOSERV
                JOIN FCM_CATEGORIAMANUT CAT
                  ON CAT.NRCATEGORIAMANUT = S.NRCATEGORIAMANUT
                  WHERE S.DTSOLICITACAOSERV BETWEEN SYSDATE - 14 AND SYSDATE";

      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
}

?>