<?php

namespace FM\Service;

use FM\Factory\SolicitacaoServFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class SolicitacaoServService
{

    protected $SolicitacaoServFactory;
    protected $Environment;
    protected $newCode;
    protected $FileServerService;

    public function __construct(SolicitacaoServFactory $SolicitacaoServFactory, Environment $Environment, NewCode $newCode)
    {
        $this->SolicitacaoServFactory = $SolicitacaoServFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function getSolicitacoesServDash()
    {
        return $this->SolicitacaoServFactory->getSolicitacoesServDash();
    }

    public function getSolicitacoeConvertidasOS()
    {
        return $this->SolicitacaoServFactory->getSolicitacoeConvertidasOS();
    }

    public function insertSolicitacaoServ($params)
    {
        $files = $params["files"];
        unset($params["files"]);
        $nrOrg = 20;
        $params["NRSOLICITACAOSERV"] = $this->newCode->getCodeByTableName("FCM_SOLICITACAOSERV", $nrOrg, 1, 10, true);
        $this->SolicitacaoServFactory->insertSolicitacaoServ($params);
        $this->FileServerService->uploadImgSolicitacaoServ($files, $params["NRSOLICITACAOSERV"]);
    }
}
