import { ZdPage } from '@zeedhi/vue';

const routes = [
  {
    path: '/auth/login',
    name: 'login',
    component: ZdPage,
    props: {
      path: 'login',
      local: true,
    },
  },
  {
    path: '/',
    name: 'home',
    component: ZdPage,
    props: () => ({
      path: 'home',
      local: true,
    }),
  },
  {
    path: '/modules/:module/:page',
    name: 'microservice',
    component: () => import('../views/Microservice.vue'),
  },
  {
    path: '*',
    component: ZdPage,
    props: {
      path: 'notfound',
      local: true,
    },
  },
  {
    path: '/dashboard',
    name: 'dashboard',
    component: ZdPage,
    props: () => ({
      path: 'layout_dashboard',
      local: true,
    }),
  },
  {
    path: '/notificacao',
    name: 'notificacao',
    component: ZdPage,
    props: () => ({
      path: 'layout_notificacao',
      local: true,
    }),
  },
];

export default routes;
